// $Id: nrembrowser.js,v 1.1.2.5 2010/06/30 16:32:04 aaron Exp $
(function ($) {

// @todo Array syntax required; 'break' is a predefined token in JavaScript.
Drupal.wysiwyg.plugins['nrembrowser'] = {

  /**
   * Return whether the passed node belongs to this plugin.
   */
  isNode: function(node) {
    return ($(node).is('img.wysiwyg-nrembrowser'));
  },

  /**
   * Execute the button.
   */
  invoke: function(data, settings, instanceId) {
    if (data.format == 'html') {
      // Launch the browser.
      Drupal.nrembrowser.dialog();
      var content = this._getPlaceholder(settings);
    }
    if (typeof content != 'undefined') {
      Drupal.wysiwyg.instances[instanceId].insert(content);
    }
  },

  /**
   * Replace all [[nid:123]] tags with images.
   */
  attach: function(content, settings, instanceId) {
    return content.replace(/\[\[nid:(\d+)\]\]/gi, function(match, nid) { return Drupal.wysiwyg.plugins.nrembrowser._getPlaceholder(settings, nid); });
  },

  /**
   * Replace images with [[nid:123]] tags in content upon detaching editor.
   */
  detach: function(content, settings, instanceId) {
    var $content = $('<div>' + content + '</div>'); // No .outerHTML() in jQuery :(
    // #404532: document.createComment() required or IE will strip the comment.
    // #474908: IE 8 breaks when using jQuery methods to replace the elements.
    // @todo Add a generic implementation for all Drupal plugins for this.
    $.each($('img.wysiwyg-nrembrowser', $content), function (i, elem) {
      $(elem).replaceWith($(elem).attr('alt'));
    });
    return $content.html();
  },

  _placeholderCount: 0,

  /**
   * Helper function to return a HTML placeholder.
   */
  _getPlaceholder: function (settings, nid) {
    if (nid) {
      // Grab source of thumbnail from nrembrowser.
      return '<img src="' + settings.global.thumbnailURL + '/' + nid + '" class="wysiwyg-nrembrowser drupal-content" alt="[[nid:' + nid + ']]" title="[[nid:' + nid + ']]" />'
    }
  }
};

})(jQuery);
